Index: branches/HTM-14.1-update-dev0/source/Lib/TLibCommon/TComSlice.h
===================================================================
--- branches/HTM-14.1-update-dev0/source/Lib/TLibCommon/TComSlice.h	(revision 1199)
+++ branches/HTM-14.1-update-dev0/source/Lib/TLibCommon/TComSlice.h	(revision 1200)
@@ -2843,5 +3024,5 @@
     || getNalUnitType() == NAL_UNIT_CODED_SLICE_BLA_W_LP;
   }
-  Bool getCraPicFlag       ()
+  Bool getCraPicFlag () const  
   {
     return getNalUnitType() == NAL_UNIT_CODED_SLICE_CRA;
@@ -2849,77 +3030,81 @@
 
   // Additional variables derived in slice header semantics 
-
+#if NH_3D
+  Int                         getNumInterLayerRefPicsMinus1Len( ) const              { return gCeilLog2(  getVPS()->getNumRefListLayers( getLayerId() )); }
+  Int                         getInterLayerPredLayerIdcLen    ( ) const              { return gCeilLog2(  getVPS()->getNumRefListLayers( getLayerId() )); }
+#else
+  Int                         getNumInterLayerRefPicsMinus1Len( ) const              { return gCeilLog2(  getVPS()->getNumDirectRefLayers( getLayerId() )); }
+  Int                         getInterLayerPredLayerIdcLen    ( ) const              { return gCeilLog2(  getVPS()->getNumDirectRefLayers( getLayerId() )); }
+#endif
+
+  Int                         getRefLayerPicFlag( Int i ) const;
+  Int                         getRefLayerPicIdc ( Int j ) const;
+  Int                         getNumRefLayerPics( ) const;
+
+  Int                         getNumActiveRefLayerPics( ) const;
+
+  Int                         getNumActiveRefLayerPics0( ) const                     { return (Int) m_refPicSetInterLayer0->size();                  };
+  Int                         getNumActiveRefLayerPics1( ) const                     { return (Int) m_refPicSetInterLayer1->size();                  };
+
+  Int                         getRefPicLayerId             ( Int i ) const;
+
+  Void                        setRefPicSetInterLayer       ( std::vector<TComPic*>* refPicSetInterLayer0, std::vector<TComPic*>* refPicSetInterLayer1);
+  TComPic*                    getPicFromRefPicSetInterLayer ( Int setIdc, Int layerId ) const ;
+
+#if NH_3D
+  // 3D-HEVC tool parameters
+  Void                        deriveInCmpPredAndCpAvailFlag( );
+  Void                        init3dToolParameters();
+  Void                        checkInCompPredRefLayers();;
+
+  Bool                        getIvMvPredFlag           ( )                          { return m_ivMvPredFlag           ;                             };
+  Bool                        getIvMvScalingFlag        ( )                          { return m_ivMvScalingFlag        ;                             };
+  Bool                        getIvResPredFlag          ( )                          { return m_ivResPredFlag          ;                             };
+  Bool                        getDepthRefinementFlag    ( )                          { return m_depthRefinementFlag    ;                             };
+  Bool                        getViewSynthesisPredFlag  ( )                          { return m_viewSynthesisPredFlag  ;                             };
+  Bool                        getDepthBasedBlkPartFlag  ( )                          { return m_depthBasedBlkPartFlag  ;                             };
+  Bool                        getMpiFlag                ( )                          { return m_mpiFlag                ;                             };
+  Bool                        getIntraContourFlag       ( )                          { return m_intraContourFlag       ;                             };
+  Bool                        getIntraSdcWedgeFlag      ( )                          { return m_intraSdcWedgeFlag      ;                             };
+  Bool                        getQtPredFlag             ( )                          { return m_qtPredFlag             ;                             };
+  Bool                        getInterSdcFlag           ( )                          { return m_interSdcFlag           ;                             };
+  Bool                        getDepthIntraSkipFlag     ( )                          { return m_depthIntraSkipFlag     ;                             };
+
+  Int                         getMpiSubPbSize           ( )                          { return m_mpiSubPbSize           ;                             };
+  Int                         getSubPbSize              ( )                          { return m_subPbSize              ;                             };
+#endif
+  // Inference 
+  Bool                        inferPocMsbValPresentFlag();
+#endif
 #if H_3D
-  Int  getNumInterLayerRefPicsMinus1Len( ) { return gCeilLog2(  getVPS()->getNumRefListLayers( getLayerId() )); }
-  Int  getInterLayerPredLayerIdcLen    ( ) { return gCeilLog2(  getVPS()->getNumRefListLayers( getLayerId() )); }
-#else
-  Int  getNumInterLayerRefPicsMinus1Len( ) { return gCeilLog2(  getVPS()->getNumDirectRefLayers( getLayerId() )); }
-  Int  getInterLayerPredLayerIdcLen    ( ) { return gCeilLog2(  getVPS()->getNumDirectRefLayers( getLayerId() )); }
-#endif
-
-
-  Int  getRefLayerPicFlag( Int i ); 
-  Int  getRefLayerPicIdc ( Int j ); 
-  Int  getNumRefLayerPics( ); 
-
-  Int  getNumActiveRefLayerPics( );
-
-  Int  getNumActiveRefLayerPics0( )        { return (Int) m_refPicSetInterLayer0->size();  };
-  Int  getNumActiveRefLayerPics1( )        { return (Int) m_refPicSetInterLayer1->size();  };
-
-  Int  getRefPicLayerId               ( Int i );
-
-  Void     setRefPicSetInterLayer       ( std::vector<TComPic*>* refPicSetInterLayer0, std::vector<TComPic*>* refPicSetInterLayer1);
-  TComPic* getPicFromRefPicSetInterLayer( Int setIdc, Int layerId );
-
-
-#if H_3D
-  // 3D-HEVC tool parameters
-  Void deriveInCmpPredAndCpAvailFlag();
-  Void init3dToolParameters();   
-  Void checkInCompPredRefLayers();;
-
-  Bool getIvMvPredFlag           ( ) { return m_ivMvPredFlag           ; };
-  Bool getIvMvScalingFlag        ( ) { return m_ivMvScalingFlag        ; };
-  Bool getIvResPredFlag          ( ) { return m_ivResPredFlag          ; };
-  Bool getDepthRefinementFlag    ( ) { return m_depthRefinementFlag    ; };
-  Bool getViewSynthesisPredFlag  ( ) { return m_viewSynthesisPredFlag  ; };
-  Bool getDepthBasedBlkPartFlag  ( ) { return m_depthBasedBlkPartFlag  ; };
-  Bool getMpiFlag                ( ) { return m_mpiFlag                ; };
-  Bool getIntraContourFlag       ( ) { return m_intraContourFlag       ; };
-  Bool getIntraSdcWedgeFlag      ( ) { return m_intraSdcWedgeFlag      ; };
-  Bool getQtPredFlag             ( ) { return m_qtPredFlag             ; };
-  Bool getInterSdcFlag           ( ) { return m_interSdcFlag           ; };
-  Bool getDepthIntraSkipFlag     ( ) { return m_depthIntraSkipFlag     ; };
-
-  Int  getMpiSubPbSize           ( ) { return m_mpiSubPbSize           ; }; 
-  Int  getSubPbSize              ( ) { return m_subPbSize              ; }; 
-#endif
-
-
-  // Inference 
-  Bool inferPocMsbValPresentFlag();  
-#endif
-#if H_3D
-  Int  getDefaultRefViewIdx() { return m_iDefaultRefViewIdx; }
-  Void setDefaultRefViewIdx(Int iViewIdx) { m_iDefaultRefViewIdx = iViewIdx; }
-
-  Bool getDefaultRefViewIdxAvailableFlag() { return m_bDefaultRefViewIdxAvailableFlag; }
-  Void setDefaultRefViewIdxAvailableFlag(Bool bViewIdx) { m_bDefaultRefViewIdxAvailableFlag = bViewIdx; }
-  Void setDefaultRefView( );
+  Int                         getDefaultRefViewIdx()                                 { return m_iDefaultRefViewIdx;                                  }
+  Void                        setDefaultRefViewIdx(Int iViewIdx)                     { m_iDefaultRefViewIdx = iViewIdx;                              }
+
+  Bool                        getDefaultRefViewIdxAvailableFlag()                    { return m_bDefaultRefViewIdxAvailableFlag;                     }
+  Void                        setDefaultRefViewIdxAvailableFlag(Bool bViewIdx)       { m_bDefaultRefViewIdxAvailableFlag = bViewIdx;                 }
+  Void                        setDefaultRefView( );
 #endif
 protected:
-  TComPic*  xGetRefPic  (TComList<TComPic*>& rcListPic,
-                         Int                 poc);
-TComPic*  xGetLongTermRefPic(TComList<TComPic*>& rcListPic, Int poc, Bool pocHasMsb);
-#if H_MV
-  TComPic*  xGetInterLayerRefPic( std::vector<TComPic*>& rcListIlPic, Int layerId );  
+  TComPic*                    xGetRefPic        (TComList<TComPic*>& rcListPic, Int poc);
+  TComPic*                    xGetLongTermRefPic(TComList<TComPic*>& rcListPic, Int poc, Bool pocHasMsb);
+#if NH_MV
+  TComPic*                    xGetInterLayerRefPic( std::vector<TComPic*>& rcListIlPic, Int layerId );  
 #endif
 };// END CLASS DEFINITION TComSlice
 
+
+Void calculateParameterSetChangedFlag(Bool &bChanged, const std::vector<UChar> *pOldData, const std::vector<UChar> &newData);
 
 template <class T> class ParameterSetMap
 {
 public:
+  template <class Tm>
+  struct MapData
+  {
+    Bool                  bChanged;
+    std::vector<UChar>   *pNaluData; // Can be null
+    Tm*                   parameterSet;
+  };
+
   ParameterSetMap(Int maxId)
   :m_maxId (maxId)
@@ -2928,43 +3113,72 @@
   ~ParameterSetMap()
   {
-    for (typename std::map<Int,T *>::iterator i = m_paramsetMap.begin(); i!= m_paramsetMap.end(); i++)
+    for (typename std::map<Int,MapData<T> >::iterator i = m_paramsetMap.begin(); i!= m_paramsetMap.end(); i++)
     {
-      delete (*i).second;
+      delete (*i).second.pNaluData;
+      delete (*i).second.parameterSet;
     }
   }
 
-  Void storePS(Int psId, T *ps)
+  Void storePS(Int psId, T *ps, const std::vector<UChar> &naluData)
   {
     assert ( psId < m_maxId );
     if ( m_paramsetMap.find(psId) != m_paramsetMap.end() )
     {
-      delete m_paramsetMap[psId];
+      MapData<T> &mapData=m_paramsetMap[psId];
+
+      // work out changed flag
+      calculateParameterSetChangedFlag(mapData.bChanged, mapData.pNaluData, naluData);
+      delete m_paramsetMap[psId].pNaluData;
+      delete m_paramsetMap[psId].parameterSet;
+
+      m_paramsetMap[psId].parameterSet = ps;
     }
-    m_paramsetMap[psId] = ps; 
+    else
+    {
+      m_paramsetMap[psId].parameterSet = ps;
+      m_paramsetMap[psId].bChanged = false;
+    }
+      m_paramsetMap[psId].pNaluData=new std::vector<UChar>;
+    *(m_paramsetMap[psId].pNaluData) = naluData;
   }
 
-  Void mergePSList(ParameterSetMap<T> &rPsList)
+  Void clearChangedFlag(Int psId)
   {
-    for (typename std::map<Int,T *>::iterator i = rPsList.m_paramsetMap.begin(); i!= rPsList.m_paramsetMap.end(); i++)
+    if ( m_paramsetMap.find(psId) != m_paramsetMap.end() )
     {
-      storePS(i->first, i->second);
+      m_paramsetMap[psId].bChanged=false;
     }
-    rPsList.m_paramsetMap.clear();
   }
 
+  Bool getChangedFlag(Int psId) const
+  {
+    const typename std::map<Int,MapData<T> >::const_iterator constit=m_paramsetMap.find(psId);
+    if ( constit != m_paramsetMap.end() )
+    {
+      return constit->second.bChanged;
+    }
+    return false;
+  }
 
   T* getPS(Int psId)
   {
-    return ( m_paramsetMap.find(psId) == m_paramsetMap.end() ) ? NULL : m_paramsetMap[psId];
+    typename std::map<Int,MapData<T> >::iterator it=m_paramsetMap.find(psId);
+    return ( it == m_paramsetMap.end() ) ? NULL : (it)->second.parameterSet;
+  }
+
+  const T* getPS(Int psId) const
+  {
+    typename std::map<Int,MapData<T> >::const_iterator it=m_paramsetMap.find(psId);
+    return ( it == m_paramsetMap.end() ) ? NULL : (it)->second.parameterSet;
   }
 
   T* getFirstPS()
   {
-    return (m_paramsetMap.begin() == m_paramsetMap.end() ) ? NULL : m_paramsetMap.begin()->second;
+    return (m_paramsetMap.begin() == m_paramsetMap.end() ) ? NULL : m_paramsetMap.begin()->second.parameterSet;
   }
 
 private:
-  std::map<Int,T *> m_paramsetMap;
-  Int               m_maxId;
+  std::map<Int,MapData<T> > m_paramsetMap;
+  Int                       m_maxId;
 };
 
@@ -2972,64 +3186,66 @@
 {
 public:
-  ParameterSetManager();
-  virtual ~ParameterSetManager();
-
-  //! store sequence parameter set and take ownership of it 
-  Void storeVPS(TComVPS *vps) { m_vpsMap.storePS( vps->getVPSId(), vps); };
-  //! get pointer to existing video parameter set  
-  TComVPS* getVPS(Int vpsId)  { return m_vpsMap.getPS(vpsId); };
-  TComVPS* getFirstVPS()      { return m_vpsMap.getFirstPS(); };
-  
-  //! store sequence parameter set and take ownership of it 
-  Void storeSPS(TComSPS *sps) { m_spsMap.storePS( sps->getSPSId(), sps); };
-  //! get pointer to existing sequence parameter set  
-  TComSPS* getSPS(Int spsId)  { return m_spsMap.getPS(spsId); };
-  TComSPS* getFirstSPS()      { return m_spsMap.getFirstPS(); };
-
-  //! store picture parameter set and take ownership of it 
-  Void storePPS(TComPPS *pps) { m_ppsMap.storePS( pps->getPPSId(), pps); };
-  //! get pointer to existing picture parameter set  
-  TComPPS* getPPS(Int ppsId)  { return m_ppsMap.getPS(ppsId); };
-  TComPPS* getFirstPPS()      { return m_ppsMap.getFirstPS(); };
+                 ParameterSetManager();
+  virtual        ~ParameterSetManager();
+
+  //! store sequence parameter set and take ownership of it
+  Void           storeVPS(TComVPS *vps, const std::vector<UChar> &naluData) { m_vpsMap.storePS( vps->getVPSId(), vps, naluData); };
+  //! get pointer to existing video parameter set
+  TComVPS*       getVPS(Int vpsId)                                           { return m_vpsMap.getPS(vpsId); };
+  Bool           getVPSChangedFlag(Int vpsId) const                          { return m_vpsMap.getChangedFlag(vpsId); }
+  Void           clearVPSChangedFlag(Int vpsId)                              { m_vpsMap.clearChangedFlag(vpsId); }
+  TComVPS*       getFirstVPS()                                               { return m_vpsMap.getFirstPS(); };
+
+  //! store sequence parameter set and take ownership of it
+  Void           storeSPS(TComSPS *sps, const std::vector<UChar> &naluData) { m_spsMap.storePS( sps->getSPSId(), sps, naluData); };
+  //! get pointer to existing sequence parameter set
+  TComSPS*       getSPS(Int spsId)                                           { return m_spsMap.getPS(spsId); };
+  Bool           getSPSChangedFlag(Int spsId) const                          { return m_spsMap.getChangedFlag(spsId); }
+  Void           clearSPSChangedFlag(Int spsId)                              { m_spsMap.clearChangedFlag(spsId); }
+  TComSPS*       getFirstSPS()                                               { return m_spsMap.getFirstPS(); };
+
+  //! store picture parameter set and take ownership of it
+  Void           storePPS(TComPPS *pps, const std::vector<UChar> &naluData) { m_ppsMap.storePS( pps->getPPSId(), pps, naluData); };
+  //! get pointer to existing picture parameter set
+  TComPPS*       getPPS(Int ppsId)                                           { return m_ppsMap.getPS(ppsId); };
+  Bool           getPPSChangedFlag(Int ppsId) const                          { return m_ppsMap.getChangedFlag(ppsId); }
+  Void           clearPPSChangedFlag(Int ppsId)                              { m_ppsMap.clearChangedFlag(ppsId); }
+  TComPPS*       getFirstPPS()                                               { return m_ppsMap.getFirstPS(); };
 
   //! activate a SPS from a active parameter sets SEI message
   //! \returns true, if activation is successful
-#if H_MV
-  Bool activateSPSWithSEI(Int SPSId, Int layerId );
+#if NH_MV
+  // Bool           activateSPSWithSEI(Int SPSId, Int layerId );
 #else
-  Bool activateSPSWithSEI(Int SPSId);
+  // Bool           activateSPSWithSEI(Int SPSId);
 #endif
 
   //! activate a PPS and depending on isIDR parameter also SPS and VPS
   //! \returns true, if activation is successful
-#if H_MV
-  Bool activatePPS(Int ppsId, Bool isIRAP, Int layerId );
+#if NH_MV
+  Bool           activatePPS(Int ppsId, Bool isIRAP, Int layerId );
 #else
-  Bool activatePPS(Int ppsId, Bool isIRAP);
-#endif
-
-  TComVPS* getActiveVPS(){ return m_vpsMap.getPS(m_activeVPSId); };
-#if H_MV
-  TComSPS* getActiveSPS( Int layerId ){ return m_spsMap.getPS( m_activeSPSId[ layerId ] ); };
-  TComPPS* getActivePPS( Int layerId ){ return m_ppsMap.getPS( m_activePPSId[ layerId ] ); };
-#else
-  TComSPS* getActiveSPS(){ return m_spsMap.getPS(m_activeSPSId); };
-  TComPPS* getActivePPS(){ return m_ppsMap.getPS(m_activePPSId); };
-#endif
+  Bool           activatePPS(Int ppsId, Bool isIRAP);
+#endif
+
+  const TComVPS* getActiveVPS()const { return m_vpsMap.getPS(m_activeVPSId); };
+
+#if NH_MV  
+  const TComSPS* getActiveSPS( Int layer )const { return m_spsMap.getPS(m_activeSPSId[layer]); };
+#else  
+  const TComSPS* getActiveSPS()const { return m_spsMap.getPS(m_activeSPSId); };
+#endif
+
 protected:
-  
   ParameterSetMap<TComVPS> m_vpsMap;
-  ParameterSetMap<TComSPS> m_spsMap; 
+  ParameterSetMap<TComSPS> m_spsMap;
   ParameterSetMap<TComPPS> m_ppsMap;
 
-  Int m_activeVPSId;
-#if H_MV
-  Int m_activeSPSId[ MAX_NUM_LAYERS ];
-  Int m_activePPSId[ MAX_NUM_LAYERS ];
-#else
-  Int m_activeSPSId;
-  Int m_activePPSId;
-#endif
-
+  Int m_activeVPSId; // -1 for nothing active
+#if NH_MV  
+  Int m_activeSPSId[ MAX_NUM_LAYERS ]; // -1 for nothing active
+#else  
+  Int m_activeSPSId; // -1 for nothing active
+#endif
 };
 
Index: branches/HTM-14.1-update-dev0/source/Lib/TLibCommon/TComTU.cpp
===================================================================
--- branches/HTM-14.1-update-dev0/source/Lib/TLibCommon/TComTU.cpp	(revision 1200)
+++ branches/HTM-14.1-update-dev0/source/Lib/TLibCommon/TComTU.cpp	(revision 1200)
@@ -0,0 +1,263 @@
+/* The copyright in this software is being made available under the BSD
+ * License, included below. This software may be subject to other third party
+ * and contributor rights, including patent rights, and no such rights are
+ * granted under this license.
+ *
+ * Copyright (c) 2010-2015, ITU/ISO/IEC
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions are met:
+ *
+ *  * Redistributions of source code must retain the above copyright notice,
+ *    this list of conditions and the following disclaimer.
+ *  * Redistributions in binary form must reproduce the above copyright notice,
+ *    this list of conditions and the following disclaimer in the documentation
+ *    and/or other materials provided with the distribution.
+ *  * Neither the name of the ITU/ISO/IEC nor the names of its contributors may
+ *    be used to endorse or promote products derived from this software without
+ *    specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
+ * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+ * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+ * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS
+ * BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
+ * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
+ * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
+ * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
+ * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
+ * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF
+ * THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+
+#include "TComTU.h"
+#include "TComRom.h"
+#include "TComDataCU.h"
+#include "TComPic.h"
+
+//----------------------------------------------------------------------------------------------------------------------
+
+/*static*/ const UInt TComTU::NUMBER_OF_SECTIONS[TComTU::NUMBER_OF_SPLIT_MODES] = { 1, 2, 4 };
+
+static     const UInt         partIdxStepShift  [TComTU::NUMBER_OF_SPLIT_MODES] = { 0, 1, 2 };
+
+//----------------------------------------------------------------------------------------------------------------------
+
+TComTU::TComTU(TComDataCU *pcCU, const UInt absPartIdxCU, const UInt cuDepth, const UInt initTrDepthRelCU)
+  : mChromaFormat(pcCU->getSlice()->getSPS()->getChromaFormatIdc()),
+    mbProcessLastOfLevel(true), // does not matter. the top level is not 4 quadrants.
+    mCuDepth(cuDepth),
+    mSection(0),
+    mSplitMode(DONT_SPLIT),
+    mAbsPartIdxCU(absPartIdxCU),
+    mAbsPartIdxTURelCU(0),
+    mAbsPartIdxStep(pcCU->getPic()->getNumPartitionsInCtu() >> (pcCU->getDepth(absPartIdxCU)<<1)),
+    mpcCU(pcCU),
+    mLog2TrLumaSize(0),
+    mpParent(NULL)
+{
+  const TComSPS *pSPS=pcCU->getSlice()->getSPS();
+  mLog2TrLumaSize = g_aucConvertToBit[pSPS->getMaxCUWidth() >> (mCuDepth+initTrDepthRelCU)]+2;
+
+  const UInt baseOffset444=pcCU->getPic()->getMinCUWidth()*pcCU->getPic()->getMinCUHeight()*absPartIdxCU;
+
+  for(UInt i=0; i<MAX_NUM_COMPONENT; i++)
+  {
+    mTrDepthRelCU[i] = initTrDepthRelCU;
+    const UInt csx=getComponentScaleX(ComponentID(i), mChromaFormat);
+    const UInt csy=getComponentScaleY(ComponentID(i), mChromaFormat);
+    mOrigWidth[i]=mRect[i].width = (i < getNumberValidComponents(mChromaFormat)) ? (pcCU->getWidth( absPartIdxCU) >> csx) : 0;
+    mRect[i].height              = (i < getNumberValidComponents(mChromaFormat)) ? (pcCU->getHeight(absPartIdxCU) >> csy) : 0;
+    mRect[i].x0=0;
+    mRect[i].y0=0;
+    mCodeAll[i]=true;
+    mOffsets[i]=baseOffset444>>(csx+csy);
+  }
+}
+
+
+
+TComTURecurse::TComTURecurse(      TComDataCU *pcCU,
+                             const UInt        absPartIdxCU)
+  : TComTU(pcCU, absPartIdxCU, pcCU->getDepth(absPartIdxCU), 0)
+{ }
+
+
+
+TComTU::TComTU(TComTU &parent, const Bool bProcessLastOfLevel, const TU_SPLIT_MODE splitMode, const Bool splitAtCurrentDepth, const ComponentID absPartIdxSourceComponent)
+  : mChromaFormat(parent.mChromaFormat),
+    mbProcessLastOfLevel(bProcessLastOfLevel),
+    mCuDepth(parent.mCuDepth),
+    mSection(0),
+    mSplitMode(splitMode),
+    mAbsPartIdxCU(parent.mAbsPartIdxCU),
+    mAbsPartIdxTURelCU(parent.GetRelPartIdxTU(absPartIdxSourceComponent)),
+    mAbsPartIdxStep(std::max<UInt>(1, (parent.GetAbsPartIdxNumParts(absPartIdxSourceComponent) >> partIdxStepShift[splitMode]))),
+    mpcCU(parent.mpcCU),
+    mLog2TrLumaSize(parent.mLog2TrLumaSize - ((splitMode != QUAD_SPLIT) ? 0 : 1)), //no change in width for vertical split
+    mpParent(&parent)
+{
+  for(UInt i=0; i<MAX_NUM_COMPONENT; i++)
+  {
+    mTrDepthRelCU[i] = parent.mTrDepthRelCU[i] + ((splitAtCurrentDepth || (splitMode == DONT_SPLIT)) ? 0 : 1);
+  }
+
+  if (mSplitMode==DONT_SPLIT)
+  {
+    for(UInt i=0; i<MAX_NUM_COMPONENT; i++)
+    {
+      mRect[i] = (parent.mRect[i]);
+      mOffsets[i]=parent.mOffsets[i];
+      mCodeAll[i]=true; // The 1 TU at this level is coded.
+      mOrigWidth[i]=mRect[i].width;
+    }
+    return;
+  }
+  else if (mSplitMode==VERTICAL_SPLIT)
+  {
+    for(UInt i=0; i<MAX_NUM_COMPONENT; i++)
+    {
+      mRect[i].x0 = (parent.mRect[i].x0);
+      mRect[i].y0 = (parent.mRect[i].y0);
+      mRect[i].width  = (parent.mRect[i].width);
+      mRect[i].height = (parent.mRect[i].height)>>1;
+      mOffsets[i]=parent.mOffsets[i];
+      mCodeAll[i]=true; // The 2 TUs at this level is coded.
+      mOrigWidth[i]=mRect[i].width;
+    }
+    return;
+  }
+
+  for(UInt i=0; i<MAX_NUM_COMPONENT; i++)
+  {
+    mRect[i].width = (parent.mRect[i].width >> 1);
+    mRect[i].height= (parent.mRect[i].height>> 1);
+    mRect[i].x0=parent.mRect[i].x0;
+    mRect[i].y0=parent.mRect[i].y0;
+    mOffsets[i]=parent.mOffsets[i];
+
+    if ((mRect[i].width < MIN_TU_SIZE || mRect[i].height < MIN_TU_SIZE) && mRect[i].width!=0)
+    {
+      const UInt numPels=mRect[i].width * mRect[i].height;
+      if (numPels < (MIN_TU_SIZE*MIN_TU_SIZE))
+      {
+        // this level doesn't have enough pixels to have 4 blocks of any relative dimension
+        mRect[i].width = parent.mRect[i].width;
+        mRect[i].height= parent.mRect[i].height;
+        mCodeAll[i]=false; // go up a level, so only process one entry of a quadrant
+        mTrDepthRelCU[i]--;
+      }
+      else if (mRect[i].width < mRect[i].height)
+      {
+        mRect[i].width=MIN_TU_SIZE;
+        mRect[i].height=numPels/MIN_TU_SIZE;
+        mCodeAll[i]=true;
+      }
+      else
+      {
+        mRect[i].height=MIN_TU_SIZE;
+        mRect[i].width=numPels/MIN_TU_SIZE;
+        mCodeAll[i]=true;
+      }
+    }
+    else
+    {
+      mCodeAll[i]=true;
+    }
+
+    mOrigWidth[i]=mRect[i].width;
+    if (!mCodeAll[i] && mbProcessLastOfLevel)
+    {
+      mRect[i].width=0;
+    }
+  }
+}
+
+Bool TComTURecurse::nextSection(const TComTU &parent)
+{
+  if (mSplitMode==DONT_SPLIT)
+  {
+    mSection++;
+    return false;
+  }
+  else
+  {
+    for(UInt i=0; i<MAX_NUM_COMPONENT; i++)
+    {
+      mOffsets[i]+=mRect[i].width*mRect[i].height;
+      if (mbProcessLastOfLevel)
+      {
+        mRect[i].width=mOrigWidth[i];
+      }
+      mRect[i].x0+=mRect[i].width;
+      const TComRectangle &parentRect=parent.getRect(ComponentID(i));
+      if (mRect[i].x0 >= parentRect.x0+parentRect.width)
+      {
+        mRect[i].x0=parentRect.x0;
+        mRect[i].y0+=mRect[i].height;
+      }
+      if (!mCodeAll[i])
+      {
+        if (!mbProcessLastOfLevel || mSection!=2)
+        {
+          mRect[i].width=0;
+        }
+      }
+    }
+    assert(mRect[COMPONENT_Cb].x0==mRect[COMPONENT_Cr].x0);
+    assert(mRect[COMPONENT_Cb].y0==mRect[COMPONENT_Cr].y0);
+    assert(mRect[COMPONENT_Cb].width==mRect[COMPONENT_Cr].width);
+    assert(mRect[COMPONENT_Cb].height==mRect[COMPONENT_Cr].height);
+
+    mAbsPartIdxTURelCU+=mAbsPartIdxStep;
+    mSection++;
+    return mSection< (1<<mSplitMode);
+  }
+}
+
+
+UInt TComTU::GetEquivalentLog2TrSize(const ComponentID compID)     const
+{
+  return g_aucConvertToBit[ getRect(compID).height ] + 2;
+}
+
+
+Bool TComTU::useDST(const ComponentID compID)
+{
+        TComDataCU *const pcCU       = getCU();
+  const UInt              absPartIdx = GetAbsPartIdxTU(compID);
+
+  return isLuma(compID) && pcCU->isIntra(absPartIdx);
+}
+
+
+Bool TComTU::isNonTransformedResidualRotated(const ComponentID compID)
+{
+  // rotation only for 4x4 intra, and is only used for non-transformed blocks (the latter is not checked here)
+  return    getCU()->getSlice()->getSPS()->getSpsRangeExtension().getTransformSkipRotationEnabledFlag()
+         && mRect[compID].width == 4
+         && getCU()->isIntra(GetAbsPartIdxTU());
+}
+
+
+UInt TComTU::getGolombRiceStatisticsIndex(const ComponentID compID)
+{
+        TComDataCU *const pcCU             = getCU();
+  const UInt              absPartIdx       = GetAbsPartIdxTU(compID);
+  const Bool              transformSkip    = pcCU->getTransformSkip(absPartIdx, compID);
+  const Bool              transquantBypass = pcCU->getCUTransquantBypass(absPartIdx);
+
+  //--------
+
+  const UInt channelTypeOffset    =  isChroma(compID)                   ? 2 : 0;
+  const UInt nonTransformedOffset = (transformSkip || transquantBypass) ? 1 : 0;
+
+  //--------
+
+  const UInt selectedIndex = channelTypeOffset + nonTransformedOffset;
+  assert(selectedIndex < RExt__GOLOMB_RICE_ADAPTATION_STATISTICS_SETS);
+
+  return selectedIndex;
+}
